#!/bin/env python3
from flask import Flask, request, jsonify
# import asyncio
import websocket
import json
import random

app = Flask(__name__)

hooks = {}
hooks['2345555XE'] = '#Bottest'

def sendmessage(target, message):
    print("Sendmessage %s called to %s" % (message, target))
    uri = "ws://localhost:5080"
    #message = "#Bottest Hello, world!"
    msg = ("%s %s" % (target, message))

    # Create a unique correlation ID
    command = {
        "corrId": f"id{random.randint(0, 999999)}",
        "cmd": msg,
    }
    json_command = json.dumps(command)

    """ Connects to WebSocket server, sends a message, and returns the response """
    ws = websocket.create_connection(uri)  # Blocking WebSocket connection
    ws.send(json_command)  # Send message to WebSocket
    response = ws.recv()  # Receive response
    ws.close()  # Close WebSocket connection
    print(response)
    return response

@app.route("/webhook/<id>", methods=['POST'])
def webhook_receiver(id):
    print("Webhook id %s" % (id))
    data = request.json  # Get the JSON data from the incoming request
    # Process the data and perform actions based on the event
    print("Received webhook data:", data)

    target = hooks.get(id)
    print(target)
    sendmessage(target, data.get('message'))

    return jsonify({'message': 'Webhook received successfully'}), 200


if __name__ == '__main__':
    app.run(debug=True)
